/*
 * Shared library gunk.
 *
 */
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xw/Xw.h>
#include <Xw/XwP.h>
#include <Xw/TraversalP.h>
#include <Xw/CreateTileP.h>
#include <Xw/MapEventsP.h>
#include <Xw/TextEditP.h>

XSegment _XwArrowpt[500];
Atom _XwButtonwidget_name = 0;
Boolean _XwButtonfirst=True;
Boolean _XwDisplayinitialized = FALSE;
XContext _XwDisplayasciiSinkContext = 0;
unsigned _XwDisplaybufferSize = 200;
unsigned char *_XwDisplaybuf = NULL;
int _XwFormdepth = 0, _XwFormleaves = 0, _XwFormarrayIndex = 0;
Arg _XwListArgs[25];
int _XwListminusOne = (-1);
int _XwListzero = 0;
Dimension _XwListRCjunk0 = 0;
Dimension _XwListRCjunk1 = 0;
Arg _XwListRCrcArgs[2];
XtTranslations _XwListbbXlations;
XtTranslations _XwListelementXlations;
Boolean _XwMapEventsinitialized = FALSE;
char _XwMapEventsbuffer[(sizeof(Widget) << 1) + 1];
XtWidgetGeometry	_XwPanelmyreq;
int _XwValuatorinitialX = 0;
int _XwValuatorinitialY = 0;
int _XwValuatorseparationX = 0;
int _XwValuatorseparationY = 0;
Boolean _XwVPWdefFalse = False;
int _XwVPWdef1 = 1;
int _XwVPWdefM1 = 10000;
_XwCheckListEntry * _XwCheckList = NULL;
int                 _XwCheckListSize = 0;
int                 _XwCheckListIndex = 0;
char _XwPopupMgrworkArea[300];
CacheEntry *_XwCreateTilepixmapCache = NULL;

EventKey _XwMapEventsmodifierStrings[] = {

  /* Modifier,  Quark,  Mask */

    {"None",    0,      0,    NULL, None},
    {"Shift",	0,      0,    NULL, ShiftMask},
    {"Lock",	0,      0,    NULL, LockMask},
    {"Ctrl",	0,      0,    NULL, ControlMask},
    {"Mod1",	0,      0,    NULL, Mod1Mask},
    {"Mod2",	0,      0,    NULL, Mod2Mask},
    {"Mod3",	0,      0,    NULL, Mod3Mask},
    {"Mod4",	0,      0,    NULL, Mod4Mask},
    {"Mod5",	0,      0,    NULL, Mod5Mask},
    {"Meta",	0,      0,    NULL, Mod1Mask},
    {NULL,      0,      0,    NULL, None},
};


EventKey _XwMapEventsbuttonEvents[] = {

/* Event Name,	  Quark, Event Type,	DetailProc	Closure */

{"Btn1Down",	    0, ButtonPress,	_XwParseImmed,	Button1},
{"Btn2Down", 	    0, ButtonPress,	_XwParseImmed,	Button2},
{"Btn3Down", 	    0, ButtonPress,	_XwParseImmed,	Button3},
{"Btn4Down", 	    0, ButtonPress,	_XwParseImmed,	Button4},
{"Btn5Down", 	    0, ButtonPress,	_XwParseImmed,	Button5},
{"Btn1Up", 	    0, ButtonRelease,   _XwParseImmed,	Button1},
{"Btn2Up", 	    0, ButtonRelease,   _XwParseImmed,	Button2},
{"Btn3Up", 	    0, ButtonRelease,   _XwParseImmed,	Button3},
{"Btn4Up", 	    0, ButtonRelease,   _XwParseImmed,	Button4},
{"Btn5Up", 	    0, ButtonRelease,   _XwParseImmed,	Button5},
{ NULL, 	    0, 0, 		 NULL, 		0}};


EventKey _XwMapEventskeyEvents[] = {

/* Event Name,	  Quark, Event Type,	DetailProc	Closure */

{"KeyPress",	    0, KeyPress,	_XwParseKeySym,	0},
{"Key", 	    0, KeyPress,	_XwParseKeySym,	0},
{"KeyDown", 	    0, KeyPress,	_XwParseKeySym,	0},
{"KeyUp", 	    0, KeyRelease,	_XwParseKeySym,	0},
{"KeyRelease", 	    0, KeyRelease,	_XwParseKeySym,	0},
{ NULL, 	    0, 0, 		NULL,		0}};


unsigned long _XwMenuBtnserial = 0;
Time _XwMenuBtntime = 0;
int _XwMenuBtntype = 0;

Cursor _XwPrimitivedefaultCursor = None;

XwAlignment	_XwResConvertAlign = XwALIGN_LEFT;
XwWidgetType	_XwResConvertWType = XwUNKNOWN;
int _XwResConvertgravity = CenterGravity;
Boolean _XwResConvertregistered = False;
#define NUMVALUESETS 7
XwSetValuePair *_XwResConvertvaluepairsets[NUMVALUESETS];

Cursor _XwSashCursor = 0;
int _XwSashdefDim = 12;
int _XwSashdefBorder = 0;

#define MAGICVALUE -1
int _XwSourceStrmagic_value = MAGICVALUE;

XComposeStatus _XwTextEditcompose_status = {NULL, 0};

XtCallbackRec _XwVPWSashCallbackInsert[] = { {(XtCallbackProc) _XwHandleSash, NULL}, {NULL, NULL} };
XtCallbackRec _XwVPWSashCallbackPaneSet[] = { {(XtCallbackProc) _XwHandleSash, NULL}, {NULL, NULL} };
